/* cos-tab.c 
 *
 * Program tiskne tabulku funknch hodnot funkce cos(x) zskanou
 * vpotem ady a standardn funkc cos() s pesnost double.
 * 
 * Sledujte nepesnost vpotu sout a vliv potu len ady
 * 
 * UPOZORNN: nejde o efektivn een, 
 *             program sestavte s matematickou knihovnou (-lm)
 * 
 * Poet prvk ady lze zadat jako argument programu (implicitn 10).
 * 
 */

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

int N = 10;			/* implicitn poet prvk ady */

double factorial(int i)
{
    double x = 1.0L;
    while (i > 1)
	x *= i--;
    return x;
}

double my_cos(double x)
{
    double sum;
    int i;
    /* vpoet prvk ady, stn od konce pro vy pesnost
     * 
     *  cos(x) = 1 - frac{x^2}{2!} + frac{x^4}{4!} - frac{x^6}{6!} + ...
     *  
     *  plat pro x v rozsahu -1 .. 1
     *
     */
    sum = 0;
    for (i = N - 1; i >= 0; i--)
	sum += ((i & 1) ? -1 : 1) * pow(x, 2 * i) / factorial(2 * i);
    return sum;
}

int main(int argc, char *argv[])
{
    double x;
    if (argc == 2)
	N = atoi(argv[1]);
    if (N < 1 || N > 50)
	return 1;
    for (x = -1.0; x <= 1.0; x += 0.01) {
	double y = my_cos(x);
	double y2 = cos(x);
	printf("%21.16f | %21.16f | %g\n", x, y, y2 - y);
    }
    return 0;
}
